<?php 

function pageWelcomeVersionOutput($currentVersion, $minimalVersion ){
	$versionOk = (version_compare($minimalVersion, $currentVersion) != 1);
	echo $currentVersion;
	if($versionOk){
		?>
		<span class="ok">(Ok)</span>
		<?php
	} else{
		?>
		<span class="error">Non supportata</span>
		(min. ver. <?php echo $minimalVersion ?>)
		<?php
	}	
}
function pageWelcome(){
	?>
	<div class="wrap pafacile-welcome">
		<div id="icon-users" class="icon32">
		<br/>
		</div>
		
		<h2>PAFacile - Mai è stato così semplice gestire il sito di un EE.LL.</h2>
		<div id="poststuff" class="has-right-sidebar">
			<div class="inner-sidebar">
				<div class="right-column">
					<div class="postbox">
						<h3>Supporto tecnico</h3>
						<ul>
							<li>
								<strong>Versione applicativa:</strong>
								<?php echo TOSENDIT_PAFACILE_VERSION?>
							</li>
							<li>
								<strong>Versione del database:</strong>
								<?php echo TOSENDIT_PAFACILE_DB_VERSION?>
							</li>
						</ul>
					</div>
					
					<div class="postbox">
						<h3>Versioni librerie</h3>
						<?php 
							$phpver = phpversion();
							if(function_exists('gd_info')){
								$gdver = gd_info();
								$gdver = $gdver['GD Version'];
							}else{
								$gdver = 'Non disponibile';
							}
							if(function_exists('curl_version')){
								$curlver = curl_version();
								$curlver = $curlver['version'];
							}else{
								$curlver = 'Non disponibile';
							}
							
							$domver = (class_exists('DOMDocument')?'Installata':'Non installata');
						?>
						<ul>
							<li>
								<strong>PHP:</strong>
								<?php pageWelcomeVersionOutput($phpver, '5.2.0'); ?>
							</li>
							<li>
								<strong>GD Lib:</strong>
								<?php pageWelcomeVersionOutput($gdver, '2.0'); ?>
								<p class="help">
									Librerie necessarie per le funzioni di presentazione dell'albero 
									dell'organigramma. Se tali funzioni non sono utilizzate si può ignorare 
									l'eventuale mancato supporto
								</p>
							</li>
							<li>
								<strong>CURL Lib:</strong>
								<?php pageWelcomeVersionOutput($curlver, '7.0'); ?><br />
								<strong>DOM Lib:</strong>
								<?php echo $domver ?><br />
								<p class="help">
									Librerie necessarie per le tabelle di monitoraggio statistico. 
									Se tale funzione non è utilizzata si può ignorare l'eventuale mancato supporto.
								</p>
							</li>
						</ul>
					</div>
					<div class="postbox">
						<h3>Link utili</h3>
						<ul>
							<li><a href="http://tosend.it">Sito dell'autore del plugin</a></li>
							<li><a href="http://tosend.it/prodotti/pafacile/">Scheda informativa PAFacile</a></li>
							<li><a href="http://twitter.com/toSendIt/">Seguici su Twitter!</a></li>
							<li><a href="http://tosend.it/prodotti/pafacile/documentazione/">Documentazione per l'utilizzatore finale e per gli sviluppatori</a></li>
							<li><a href="http://wordpress.org/extend/plugins/pafacile/">Pagina ufficiale del plugin</a></li>
							<li><a href="http://wordpress.org/tags/pafacile?forum_id=10">Forum di supporto</a></li>
						</ul>
					</div>
					<div class="postbox">
						<h3>Testimonial</h3>
						<p>
							Vuoi diventare un testimonial di PAFacile? Vuoi segnalarci la tua soddisfazione nell'utilizzo
							del plugin? <a href="mailto:easypa@tosend.it">Scrivici</a> e fallo sapere a tutti!
						</p>
					</div>
				</div>
			</div>
			<div class="left-column" id="post-body">
				<div  id="post-body-content">
				<div class="postbox">
					<h3>Cos'è?</h3>
					<p>
						<em>PAFacile</em> è un plugin sviluppato dalla <a href="http://toSend.it">toSend.it</a> per venire
						incontro alle esigenze della Pubblica Amministrazione e degli Enti Locali.
					</p>
				</div>
				<div class="postbox">
					<h3>Cosa fa?</h3>
					<p>
						<em>PAFacile</em> consente di gestire diverse caratteristiche della PA
					</p>
					<ul>
						<li>Gestione dell'albo pretorio on-line</li>
						<li>Gestione delle tipologie di atto disponibili nell'albo pretorio</li>
						<li>Gestione bandi, gare, concorsi e graduatorie</li>
						<li>Gestione delibere di giunta e consiglio</li>
						<li>Gestione determine d'ufficio</li>
						<li>Gestione degli incarichi professionali</li>
						<li>Gestione ordinanze</li>
						<li>Gestione organigramma</li>
						<li>Gestione organi di governo</li>
						<li>Gestione delle tipologie di organi di governo disponibili</li>
						<li>Gestione di più incarichi governativi ricoperti dallo stesso soggetto</li>
						<li>Tabelle di monitoraggio statistiche</li>
					</ul>
				</div>
				<div class="postbox">
					<h3>Ultimi cambiamenti</h3>
					<?php
					# Since V. 2.4.4
					$changelog = file_get_contents(dirname(__FILE__). '/readme.txt');
					
					$changelog = preg_replace('#^.*== Changelog ==#is', '', $changelog);
					
					$changelog = preg_replace('#= ' . TOSENDIT_PAFACILE_VERSION . '[^=]+=(.*?)= \d+.\d+.*#is', '$1', $changelog);
					$changelog = preg_replace('#\*\*([^\*]+)\*\*#', '<strong>$1</strong>', $changelog);
					$changelog = preg_replace('#\*([^\n]*)#is', '<li> $1 </li>',$changelog);
					$changelog = preg_replace('#\n\n<li>#', '<ul><li>', $changelog);
					$changelog .='</ul>';
					echo($changelog); 
					?>
				</div>
				<div class="postbox">
				
				
				
					<h3>Le ultime novità su PAFacile</h3>
					
					<?php // Get RSS Feed(s)
					include_once(ABSPATH . WPINC . '/feed.php');
					
					// Get a SimplePie feed object from the specified feed source.
					$rss = fetch_feed('http://tosend.it/category/pafacile/feed/rss/');
					if (!is_wp_error( $rss ) ) : // Checks that the object is created correctly 
					    // Figure out how many total items there are, but limit it to 5. 
					    $maxitems = $rss->get_item_quantity(5); 
					    // Build an array of all the items, starting with element 0 (first element).
					    $rss_items = $rss->get_items(0, $maxitems); 
					    
					endif;
					?>
					
					<ul>
					    <?php 
					    // Loop through each feed item and display each item as a hyperlink.
					    foreach ( $rss_items as $item ) {
					    	 ?>
						    <li>
						        <a href='<?php echo esc_url( $item->get_permalink() ); ?>'>
						        <?php echo esc_html( $item->get_title() ); ?></a>
						    </li>
					    	<?php 
					    }
					    ?>
					</ul>
				</div>
				
			</div>

		</div>
	</div>
	<?php 
}

pageWelcome();
?>